# Fabelous Math

Fabelous Math is a simple library designed to provide basic mathematical functions, saving you the trouble of writing these common utilities repeatedly. This library includes essential functions like checking if a number is even or odd.

## Installation

You can easily install `fabelous-math` using pip:

```sh
pip install https://gitea.fabelous.app/Fabel/fabelous-math.git
```

## Usage

### Python

To use the functions provided by Fabelous Math in your Python code, you can import them as follows:

```python
from fabelous_math import is_even, is_odd

# Example usage:
number = 42
print(f"Is {number} even? {is_even(number)}")
print(f"Is {number} odd? {is_odd(number)}")
```

## Functions

### `is_even`

Checks if a given number is even.

- **Python:**
  ```python
  def is_even(number: int) -> bool:
      pass
  ```

- **C++:**
  ```cpp
  namespace simple_functions {
      bool is_even(long long number);
  }
  ```

### `is_odd`

Checks if a given number is odd.

- **Python:**
  ```python
  def is_odd(number: int) -> bool:
      pass
  ```

- **C++:**
  ```cpp
  namespace simple_functions {
      bool is_odd(long long number);
  }
  ```
## Performance Comparison

To understand the performance of `fabelous-math` functions, I conducted a series of tests comparing my methods with traditional modulo operations. Below are the results:

### Low Numbers Performance:
![Low Numbers Performance](docs/low_numbers_comparison.png)


### High Numbers Performance:
![High Numbers Performance](docs/high_numbers_comparison.png)
